<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Chatbot Interface</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Roboto:wght@400;500&display=swap">
  <style>
    body {
      font-family: 'Roboto', sans-serif;
      margin: 0;
      background-color: #f2f2f2;
      display: flex;
      justify-content: center;
      align-items: center;
      height: 100vh;
    }
    .chat-container {
      width: 100%;
      max-width: 500px;
      background-color: white;
      border-radius: 8px;
      box-shadow: 0 4px 10px rgba(0, 0, 0, 0.1);
      overflow: hidden;
      display: flex;
      flex-direction: column;
    }
    .chat-header {
      background-color: #007bff;
      color: white;
      padding: 10px;
      text-align: center;
      font-size: 1.2em;
      font-weight: 500;
    }
    .chat-history {
      padding: 15px;
      flex-grow: 1;
      overflow-y: auto;
      max-height: 500px;
      display: flex;
      flex-direction: column;
    }
    .chat-bubble {
      margin: 5px 0;
      padding: 10px 15px;
      border-radius: 20px;
      max-width: 75%;
    }
    .user-message {
      align-self: flex-end;
      background-color: #007bff;
      color: white;
    }
    .bot-message {
      align-self: flex-start;
      background-color: #e9e9eb;
      color: #333;
    }
    .chat-input {
      display: flex;
      flex-direction: column;
      border-top: 1px solid #ddd;
      padding: 10px;
    }
    .chat-input input[type="text"],
    .chat-input input[type="date"] {
      margin-bottom: 10px;
      padding: 10px;
      font-size: 1em;
      border: 1px solid #ddd;
      border-radius: 4px;
      outline: none;
    }
    .chat-input button {
      background-color: #007bff;
      color: white;
      border: none;
      padding: 10px;
      cursor: pointer;
      font-size: 1em;
      border-radius: 4px;
    }
    .chat-input button:hover {
      background-color: #0056b3;
    }
  </style>
</head>
<body>
  <div class="chat-container">
    <div class="chat-header">Chatbot Interface</div>
    <div class="chat-history" id="chatHistory">
      <!-- Messages will appear here -->
    </div>
    <div class="chat-input">
      <input type="text" id="questionInput" placeholder="Type your question..." autocomplete="off">
      <input type="date" id="startDateInput" placeholder="Start Date">
      <input type="date" id="endDateInput" placeholder="End Date">
      <button onclick="sendMessage()">Send</button>
    </div>
  </div>

 <script>
    // Function to append messages to the chat history
    function addMessage(content, isUser) {
      const chatHistory = document.getElementById('chatHistory');
      const messageBubble = document.createElement('div');
      messageBubble.className = 'chat-bubble ' + (isUser ? 'user-message' : 'bot-message');
      messageBubble.textContent = content;
      chatHistory.appendChild(messageBubble);
      chatHistory.scrollTop = chatHistory.scrollHeight; // Scroll to the latest message
    }

    // Function to send a message
    async function sendMessage() {
      const questionInput = document.getElementById('questionInput');
      const startDateInput = document.getElementById('startDateInput');
      const endDateInput = document.getElementById('endDateInput');
      const question = questionInput.value.trim();
      const startDate = startDateInput.value;
      const endDate = endDateInput.value;

      if (!question || !startDate || !endDate) {
        addMessage("Please enter a question and specify both start and end dates.", false);
        return;
      }

      // Add user message to the chat
      addMessage(question, true);
      questionInput.value = ''; // Clear the input field

      // Send the question and dates to the server
      try {
        const response = await fetch('/ask', {
          method: 'POST',
          headers: {
            'Content-Type': 'application/x-www-form-urlencoded',
          },
          body: new URLSearchParams({
            question: question,
            start_date: startDate,
            end_date: endDate
          })
        });

        const data = await response.json();
        if (data.result && data.result.length > 0) {
          addMessage("Here's your answer:", false);
          data.result.forEach((item) => {
            addMessage(`Total hours worked: ${item.TOTAL_HOURS_WORKED}`, false);
          });
        } else if (data.message) {
          addMessage(data.message, false);
        } else {
          addMessage("No data found.", false);
        }
      } catch (error) {
        console.error("Error:", error);
        addMessage("An error occurred. Please try again later.", false);
      }
    }

  </script>
</body>
</html>
